/**************************************************************************************************
  Filename:       simpleGATTprofile.h
  Revised:
  Revision:

  Description:    This file contains the Simple GATT profile definitions and
                  prototypes.

 **************************************************************************************************/

#ifndef _BLE_CUSTOM_CONFIG_SERVICE_H
#define _BLE_CUSTOM_CONFIG_SERVICE_H

#ifdef __cplusplus
extern "C"
{
#endif

//#include "att.h"
#include "stdint.h"
#include "ble_uart_service_def.h"



#define BLE_UART_RX_BUFF_SIZE                  1

#if 1

typedef enum {
    BLE_CUSTOM_CONFIG_READ = 1,
    BLE_CUSTOM_CONFIG_WRITE,
} ble_custom_config_evt_type_t;

typedef struct
{
    uint8_t       * p_data; /**< A pointer to the buffer with received data. */
    uint16_t      * length; /**< Length of received data. */
} ble_custom_config_data_t;

typedef struct {
    ble_custom_config_evt_type_t  type;
    ble_custom_config_data_t      data;
} ble_custom_config_evt_t;

typedef void (*ble_custom_config_ProfileChangeCB_t)(uint16_t connection_handle,ble_custom_config_evt_t * p_evt);

#endif

/*********************************************************************
 * API FUNCTIONS
 */


/*
 * ble_uart_AddService- Initializes the raw pass GATT Profile service by registering
 *          GATT attributes with the GATT server.
 *
 * @param   services - services to add. This is a bit map and can
 *                     contain more than one service.
 */

extern bStatus_t ble_custom_config_service( ble_custom_config_ProfileChangeCB_t cb);


/*********************************************************************
*********************************************************************/

#ifdef __cplusplus
}
#endif

#endif /* _BLE_CUSTOM_CONFIG_SERVICE_H */

