#include "net_config.h"

#include "CH57x_common.h"



void net_config_dump(net_config_t *p_config){

    PRINT("-------net config HEX dump-------------\r\n");
    for(uint8_t i=0;i<16;i++){
        PRINT("%02X ",((uint8_t *)p_config)[i]);
    }
    PRINT("\r\n");
    PRINT("ip=%d.%d.%d.%d\r\n",p_config->local_ip_address[0],\
                               p_config->local_ip_address[1],\
                               p_config->local_ip_address[2],\
                               p_config->local_ip_address[3]);
    PRINT("mask=%d\r\n",p_config->local_ip_mask);
    
    PRINT("gw=%d.%d.%d.%d\r\n",p_config->local_gateway[0],\
                           p_config->local_gateway[1],\
                           p_config->local_gateway[2],\
                           p_config->local_gateway[3]);
    
    PRINT("target=%d.%d.%d.%d\r\n",p_config->target_ip_adddress[0],\
                           p_config->target_ip_adddress[1],\
                           p_config->target_ip_adddress[2],\
                           p_config->target_ip_adddress[3]);
    
    PRINT("PORT=%d\r\n",p_config->target_port);
}

bool net_config_vaild(net_config_t *p_config){
    uint8_t verify_ca=0;
    uint8_t *p_config_arry = (uint8_t *)p_config;

    
    printf("sizeof net_config_t = %0d\r\n",sizeof(net_config_t));
    for(uint8_t i=0;i<(sizeof(net_config_t)-1);i++){
        verify_ca += p_config_arry[i];
        PRINT("%d=%02x\r\n",i,p_config_arry[i]);
    }
    PRINT("verify_ca=%x\r\n",verify_ca);
    if(verify_ca == p_config->verify){
        return true;
    }
    return false;
}

bool net_config_save(net_config_t *p_config,uint32_t addr){

    __align(4) net_config_t net_config_temp;
    memcpy(&net_config_temp,p_config,sizeof(net_config_t));
    
    if(FlashBlockErase(addr)){
        return false;
    }
    if(0 == FlashWriteBuf(addr,(uint32_t *)&net_config_temp,sizeof(net_config_t))){
        return true;
    }
    return false;
}

bool net_config_read(net_config_t *p_config,uint32_t addr){
    if(net_config_vaild((net_config_t *)addr))
    {
        memcpy(p_config,(net_config_t *)addr,sizeof(net_config_t));
        return true;
    }
    return false;
}

bool net_config_transfer_mask_from_num_to_ip(uint8_t mask_in_num,uint8_t *mask_in_ip){
        uint32_t ip_in_32_bit=0;
    
        if(mask_in_num>32){
            return  false;
        }
        PRINT("mask %d\r\n",mask_in_num);
        for(uint8_t i=0;i<mask_in_num;i++){
            ip_in_32_bit >>=1;
            ip_in_32_bit |=0x80000000;
            PRINT("I=%d,mask=%d.%d.%d.%d\r\n",i,((uint8_t *)&ip_in_32_bit)[0],((uint8_t *)&ip_in_32_bit)[1],((uint8_t *)&ip_in_32_bit)[2],((uint8_t *)&ip_in_32_bit)[3]);
        }
        mask_in_ip[0] = ((uint8_t *)&ip_in_32_bit)[3];
        mask_in_ip[1] = ((uint8_t *)&ip_in_32_bit)[2];
        mask_in_ip[2] = ((uint8_t *)&ip_in_32_bit)[1];
        mask_in_ip[3] = ((uint8_t *)&ip_in_32_bit)[0];

        return true;
}

net_config_t net_config_test = {
        .local_ip_address[0]=192,
        .local_ip_address[1]=168,
        .local_ip_address[2]=11,
        .local_ip_address[3]=123,
    
        .local_ip_mask = 24,
        .local_gateway[0] = 192,
        .local_gateway[1] = 168,
        .local_gateway[2] = 11,
        .local_gateway[3] = 254,
        
        .target_ip_adddress[0]=112,
        .target_ip_adddress[1]=80,
        .target_ip_adddress[2]=13,
        .target_ip_adddress[3]=1,
        
        .target_port=50288,
        .verify = 0x79,
};